"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudApi = exports.api = exports.cloudApi = void 0;
const qs_1 = __importDefault(require("qs"));
const Api_1 = require("./generated/Api");
const Api_2 = require("./generated/cloud/Api");
Object.defineProperty(exports, "CloudApi", { enumerable: true, get: function () { return Api_2.Api; } });
const api = (serverUrl, token, axiosOpts) => {
    return new Api_1.Api(Object.assign({ baseURL: serverUrl, headers: {
            Authorization: `Bearer ${token}`,
        }, paramsSerializer: (params) => qs_1.default.stringify(params, { arrayFormat: 'repeat' }) }, axiosOpts));
};
exports.api = api;
const cloudApi = (serverUrl, token, axiosOpts) => {
    return new Api_2.Api(Object.assign({ baseURL: serverUrl, headers: {
            Authorization: `Bearer ${token}`,
        }, paramsSerializer: (params) => qs_1.default.stringify(params, { arrayFormat: 'repeat' }) }, axiosOpts));
};
exports.cloudApi = cloudApi;
exports.default = api;
