"use strict";
/* eslint-disable */
/* tslint:disable */
/*
 * ---------------------------------------------------------------
 * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
 * ##                                                           ##
 * ## AUTHOR: acacode                                           ##
 * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
 * ---------------------------------------------------------------
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Api = void 0;
const http_client_1 = require("./http-client");
class Api extends http_client_1.HttpClient {
    constructor() {
        super(...arguments);
        /**
         * @description Gets metadata for the Hatchet instance
         *
         * @tags Metadata
         * @name MetadataGet
         * @summary Get metadata
         * @request GET:/api/v1/cloud/metadata
         */
        this.metadataGet = (params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/metadata`, method: 'GET', format: 'json' }, params));
        /**
         * @description Starts the OAuth flow
         *
         * @tags User
         * @name UserUpdateGithubAppOauthStart
         * @summary Start OAuth flow
         * @request GET:/api/v1/cloud/users/github-app/start
         * @secure
         */
        this.userUpdateGithubAppOauthStart = (params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/users/github-app/start`, method: 'GET', secure: true }, params));
        /**
         * @description Completes the OAuth flow
         *
         * @tags User
         * @name UserUpdateGithubAppOauthCallback
         * @summary Complete OAuth flow
         * @request GET:/api/v1/cloud/users/github-app/callback
         * @secure
         */
        this.userUpdateGithubAppOauthCallback = (params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/users/github-app/callback`, method: 'GET', secure: true }, params));
        /**
         * @description Github App global webhook
         *
         * @tags Github
         * @name GithubUpdateGlobalWebhook
         * @summary Github app global webhook
         * @request POST:/api/v1/cloud/github/webhook
         */
        this.githubUpdateGlobalWebhook = (params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/github/webhook`, method: 'POST' }, params));
        /**
         * @description Github App tenant webhook
         *
         * @tags Github
         * @name GithubUpdateTenantWebhook
         * @summary Github app tenant webhook
         * @request POST:/api/v1/cloud/github/webhook/{webhook}
         */
        this.githubUpdateTenantWebhook = (webhook, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/github/webhook/${webhook}`, method: 'POST' }, params));
        /**
         * @description List Github App installations
         *
         * @tags Github
         * @name GithubAppListInstallations
         * @summary List Github App installations
         * @request GET:/api/v1/cloud/github-app/installations
         * @secure
         */
        this.githubAppListInstallations = (params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/github-app/installations`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description List Github App repositories
         *
         * @tags Github
         * @name GithubAppListRepos
         * @summary List Github App repositories
         * @request GET:/api/v1/cloud/github-app/installations/{gh-installation}/repos
         * @secure
         */
        this.githubAppListRepos = (ghInstallation, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/github-app/installations/${ghInstallation}/repos`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description List Github App branches
         *
         * @tags Github
         * @name GithubAppListBranches
         * @summary List Github App branches
         * @request GET:/api/v1/cloud/github-app/installations/{gh-installation}/repos/{gh-repo-owner}/{gh-repo-name}/branches
         * @secure
         */
        this.githubAppListBranches = (ghInstallation, ghRepoOwner, ghRepoName, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/github-app/installations/${ghInstallation}/repos/${ghRepoOwner}/${ghRepoName}/branches`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get all managed workers for the tenant
         *
         * @tags Managed Worker
         * @name ManagedWorkerList
         * @summary List Managed Workers
         * @request GET:/api/v1/cloud/tenants/{tenant}/managed-worker
         * @secure
         */
        this.managedWorkerList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/tenants/${tenant}/managed-worker`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Create a managed worker for the tenant
         *
         * @tags Managed Worker
         * @name ManagedWorkerCreate
         * @summary Create Managed Worker
         * @request POST:/api/v1/cloud/tenants/{tenant}/managed-worker
         * @secure
         */
        this.managedWorkerCreate = (tenant, data, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/tenants/${tenant}/managed-worker`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Get a managed worker for the tenant
         *
         * @tags Managed Worker
         * @name ManagedWorkerGet
         * @summary Get Managed Worker
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}
         * @secure
         */
        this.managedWorkerGet = (managedWorker, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Update a managed worker for the tenant
         *
         * @tags Managed Worker
         * @name ManagedWorkerUpdate
         * @summary Update Managed Worker
         * @request POST:/api/v1/cloud/managed-worker/{managed-worker}
         * @secure
         */
        this.managedWorkerUpdate = (managedWorker, data, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Delete a managed worker for the tenant
         *
         * @tags Managed Worker
         * @name ManagedWorkerDelete
         * @summary Delete Managed Worker
         * @request DELETE:/api/v1/cloud/managed-worker/{managed-worker}
         * @secure
         */
        this.managedWorkerDelete = (managedWorker, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}`, method: 'DELETE', secure: true, format: 'json' }, params));
        /**
         * @description Registers runtime configs via infra-as-code
         *
         * @tags Managed Worker
         * @name InfraAsCodeCreate
         * @summary Create Infra as Code
         * @request POST:/api/v1/cloud/infra-as-code/{infra-as-code-request}
         * @secure
         */
        this.infraAsCodeCreate = (infraAsCodeRequest, data, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/infra-as-code/${infraAsCodeRequest}`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json }, params));
        /**
         * @description Get a list of runtime config actions for a managed worker
         *
         * @tags Managed Worker
         * @name RuntimeConfigListActions
         * @summary Get Runtime Config Actions
         * @request GET:/api/v1/cloud/runtime-config/{runtime-config}/actions
         * @secure
         */
        this.runtimeConfigListActions = (runtimeConfig, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/runtime-config/${runtimeConfig}/actions`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get CPU metrics for a managed worker
         *
         * @tags Metrics
         * @name MetricsCpuGet
         * @summary Get CPU Metrics
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}/metrics/cpu
         * @secure
         */
        this.metricsCpuGet = (managedWorker, query, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}/metrics/cpu`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Get memory metrics for a managed worker
         *
         * @tags Metrics
         * @name MetricsMemoryGet
         * @summary Get Memory Metrics
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}/metrics/memory
         * @secure
         */
        this.metricsMemoryGet = (managedWorker, query, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}/metrics/memory`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Get disk metrics for a managed worker
         *
         * @tags Metrics
         * @name MetricsDiskGet
         * @summary Get Disk Metrics
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}/metrics/disk
         * @secure
         */
        this.metricsDiskGet = (managedWorker, query, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}/metrics/disk`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Lists logs for a managed worker
         *
         * @tags Log
         * @name LogList
         * @summary List Logs
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}/logs
         * @secure
         */
        this.logList = (managedWorker, query, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}/logs`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Get the build logs for a specific build of a managed worker
         *
         * @tags Log
         * @name IacLogsList
         * @summary Get IaC Logs
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}/iac-logs
         * @secure
         */
        this.iacLogsList = (managedWorker, query, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}/iac-logs`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Get all instances for a managed worker
         *
         * @tags Managed Worker
         * @name ManagedWorkerInstancesList
         * @summary List Instances
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}/instances
         * @secure
         */
        this.managedWorkerInstancesList = (managedWorker, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}/instances`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get a build
         *
         * @tags Build
         * @name BuildGet
         * @summary Get Build
         * @request GET:/api/v1/cloud/build/{build}
         * @secure
         */
        this.buildGet = (build, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/build/${build}`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get the build logs for a specific build of a managed worker
         *
         * @tags Log
         * @name BuildLogsList
         * @summary Get Build Logs
         * @request GET:/api/v1/cloud/build/{build}/logs
         * @secure
         */
        this.buildLogsList = (build, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/build/${build}/logs`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get events for a managed worker
         *
         * @tags Managed Worker
         * @name ManagedWorkerEventsList
         * @summary Get Managed Worker Events
         * @request GET:/api/v1/cloud/managed-worker/{managed-worker}/events
         * @secure
         */
        this.managedWorkerEventsList = (managedWorker, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/managed-worker/${managedWorker}/events`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Receive a webhook message from Lago
         *
         * @tags Billing
         * @name LagoMessageCreate
         * @summary Receive a webhook message from Lago
         * @request POST:/api/v1/billing/lago/webhook
         */
        this.lagoMessageCreate = (params = {}) => this.request(Object.assign({ path: `/api/v1/billing/lago/webhook`, method: 'POST' }, params));
        /**
         * @description Gets the billing state for a tenant
         *
         * @tags Tenant
         * @name TenantBillingStateGet
         * @summary Get the billing state for a tenant
         * @request GET:/api/v1/billing/tenants/{tenant}
         * @secure
         */
        this.tenantBillingStateGet = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/billing/tenants/${tenant}`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Update a subscription
         *
         * @tags Billing
         * @name SubscriptionUpsert
         * @summary Create a new subscription
         * @request PATCH:/api/v1/billing/tenants/{tenant}/subscription
         * @secure
         */
        this.subscriptionUpsert = (tenant, data, params = {}) => this.request(Object.assign({ path: `/api/v1/billing/tenants/${tenant}/subscription`, method: 'PATCH', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Get the billing portal link
         *
         * @tags Billing
         * @name BillingPortalLinkGet
         * @summary Create a link to the billing portal
         * @request GET:/api/v1/billing/tenants/{tenant}/billing-portal-link
         * @secure
         */
        this.billingPortalLinkGet = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/billing/tenants/${tenant}/billing-portal-link`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Push a log entry for the tenant
         *
         * @tags Log
         * @name LogCreate
         * @summary Push Log Entry
         * @request POST:/api/v1/cloud/tenants/{tenant}/logs
         * @secure
         */
        this.logCreate = (tenant, data, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/tenants/${tenant}/logs`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json }, params));
        /**
         * @description Get all feature flags for the tenant
         *
         * @tags Feature Flags
         * @name FeatureFlagsList
         * @summary List Feature Flags
         * @request GET:/api/v1/cloud/tenants/{tenant}/feature-flags
         * @secure
         */
        this.featureFlagsList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/tenants/${tenant}/feature-flags`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get a minute by minute breakdown of workflow run metrics for a tenant
         *
         * @tags Workflow
         * @name WorkflowRunEventsGetMetrics
         * @summary Get workflow runs
         * @request GET:/api/v1/cloud/tenants/{tenant}/runs-metrics
         * @secure
         */
        this.workflowRunEventsGetMetrics = (tenant, query, params = {}) => this.request(Object.assign({ path: `/api/v1/cloud/tenants/${tenant}/runs-metrics`, method: 'GET', query: query, secure: true, format: 'json' }, params));
    }
}
exports.Api = Api;
